=== debian/changelog ===
ghc-testsuite (8.0.1-1) unstable; urgency=medium

  [ Dmitry Bogatov ]
  * Bump standards version to 3.9.8 (no changes needed)
  * Convert `debian/copyright' to dep5 format

  [ Clint Adams ]
  * New upstream version.

 -- Clint Adams <clint@debian.org>  Thu, 27 Oct 2016 20:36:34 -0400
