=== debian/control ===
Source: ghc-testsuite
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>
Build-Depends:
 python,
 debhelper (>= 9),
 ghc (>= 8.0.1),
 ghc (<< 8.0.1+),
 ghc-prof,
 libghc-quickcheck2-dev,
 libghc-quickcheck2-prof,
 libghc-vector-dev,
 libghc-vector-prof,
 libghc-mtl-dev,
 libghc-mtl-prof,
 libghc-parallel-dev,
 libghc-parallel-prof,
 libghc-regex-compat-dev,
 libghc-regex-compat-prof,
 libghc-regex-posix-dev,
 libghc-regex-posix-prof,
 libghc-syb-dev,
 libghc-syb-prof,
 libghc-utf8-string-dev,
 libghc-utf8-string-prof,
 libghc-parsec3-dev,
 libghc-parsec3-prof,
Standards-Version: 3.9.8
Homepage: http://hackage.haskell.org/trac/ghc/wiki/Building/RunningTests
Vcs-Git: https://anonscm.debian.org/git/pkg-haskell/DHG_packages.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/

Package: ghc-testsuite
Architecture: any
Depends: ${misc:Depends}
Description: GHC testsuite results
 This package is just a container for the results of the GHC testsuite. There
 is usually no point in installing this package.
